
extern int BASE;
extern int IOBASE;
extern int VERBOSE;
extern int TRACE;
extern int maclevel;

#define MINARGC(x) if (argc<(x)) {do_abort("not enough arguments");return(-1);}
#define MAXARGC(x) if ((x)<=argc){do_abort("too many arguments"  );return(-1);}

unsigned int myatoi (char *str);
int getintvar (char *name);
int do_abort (char *msg);
int tstenv (int argc,char **argv);
int internal_set (char *varname,char *value);
int internal_set_int (char *varname, int value);
int my_usleep (int t);

extern FILE *logfile;


#ifdef USE_ALLOCA
#define MY_ALLOCA(x)    alloca((x))
#define MY_AFREE(x)     (void)(x)
#else
#define MY_ALLOCA(x)    MY_MALLOC((x))
#define MY_AFREE(x)     free((x))
#endif

#ifndef SQR
#define SQR(x)   ((x)*(x))
#endif

#ifndef MIN
#define MIN(x,y) (((x)<(y))?(x):(y))
#define MAX(x,y) (((x)>(y))?(x):(y))
#endif

#define MY_MALLOC(x) my_malloc((x),__LINE__,__FILE__)

static inline void*  my_malloc(int nbytes,int line,char *file) {
  void *t;

  if (!(t = malloc (nbytes))) {
    fprintf (stderr,"Out of memory in file %s, at line %d.\n",file,line);
    exit (1);
  }
  return t;
}




