
#include <stdio.h>
#include <stdlib.h>

#include "config.h"


#ifdef INCLUDE_P555

#include "chipmunk.h"
#include "p555.h"

#if 0
static int tok;

#define MAXTRY 2000

#define ISSUE_COMMAND(C) printf ("O %04x\n",C);\
                         p555->command = (C); \
                         for (tok=MAXTRY;tok;tok--) \
                             if (p555->answer == (C)) break;\
                         if (!tok) printf ("Time out\n");
#else
#define ISSUE_COMMAND(C) p555->command = (C); \
                         usleep (10)
#endif


int load_p555 (int argc,char **argv)
{
int off,ch,i;
FILE *f;
struct P555_regs *p555;

p555 = (struct P555_regs *) (BASE + myatoi (argv[1]));
off = (int) myatoi (argv[2]);
f = fopen (argv[3],"r");
if (!f)
    {
    perror (argv[3]);
    return 1;
    }

/* p555->command = C_RESET; */
ISSUE_COMMAND (C_RESET);
for (i=0;i<off;i++)
    ISSUE_COMMAND (C_INCREMENT);

while ((ch = getc (f)) != EOF)
   {
   ISSUE_COMMAND ((ch << 8) | C_LOAD_PROT_MEM);
   }   

fclose (f);
return (0);
}



int save_p555 (int argc,char **argv)
{
int off,ch,len,i;
FILE *f;
struct P555_regs *p555;

p555 = (struct P555_regs *) (BASE + myatoi (argv[1]));
off = (int) myatoi (argv[2]);
len = (int) myatoi (argv[3]);
f = fopen (argv[4],"w");
if (!f)
    {
    perror (argv[4]);
    return 1;
    }

ISSUE_COMMAND (C_RESET);
usleep (1000);
for (i=0;i<off;i++)
    ISSUE_COMMAND (C_INCREMENT);

for (i=0;i<len;i++)
    {
    ch = (p555->m_p_bus >> 24) & 0xff;
    putc (ch,f);
    ISSUE_COMMAND (C_INCREMENT);
    }
fclose (f);
return (0);
}


#endif INCLUDE_P555
